#include "ECU.H"

void InitECU()
{
	int i = 0;
	int j = 0;

	tECU.START_ECU_MEMORY = (unsigned long)&tECU.START_ECU_MEMORY;

	tECU.Value_SHORT_1 = 0;
	tECU.Value_SHORT_2 = 0;

	tECU.Value_BYTE_1 = 0;
	tECU.Value_BYTE_2 = 0;

	tECU.Measurement_BYTE_1 = 0;  
	tECU.Measurement_BYTE_2 = 0;

	tECU.Measurement_SHORT_1 = 0;
	tECU.Measurement_SHORT_2 = 0;

	for( i = 0; i < 8; i++ )
	{
		tECU.Curve_1_X_Axis[i] = i;	
		tECU.Curve_1_Y_Axis[i] = i;
		tECU.Map_1_X_Axis[i] = i;
		tECU.Map_1_Y_Axis[i] = i;
		
		for( j = 0; j < 8; j++ )
		{
			tECU.Map_1_Z_Axis[i][j] = j*i;
		}
	}
}


void Fire010MSEventECU()
{
	tECU.Measurement_SHORT_1++;
	if( tECU.Measurement_SHORT_1 > 346 )
		tECU.Measurement_SHORT_1 = 0;
		
	tECU.Measurement_BYTE_2++;	
}


void Fire100MSEventECU()
{
	tECU.Measurement_SHORT_2++;
	if( tECU.Measurement_SHORT_2 > 41 )
		tECU.Measurement_SHORT_2 = 0;
		
	tECU.Measurement_BYTE_1++;	
}


void Fire500MSEventECU()
{

}


int main()
{
	return 0;
}
