// vspy generated header file
#ifndef VSPY_GENERATED_HEADER
#define VSPY_GENERATED_HEADER
#include "windows.h"
#include "string.h"
#include <stdio.h>
extern unsigned int g_uiHandle;
typedef unsigned __int64 uint64;

#define printf Printf
int Printf(const char *szInMsg, ...);
int PrintfW(const wchar_t *szInMsg, ...);
int WriteLine(const char *szInMsg, ...);
int WriteLineW(const wchar_t *szInMsg, ...);
void DisplayLastError(LPCWSTR lpszFunction);

typedef void (* RS232OnError_fdef)(DWORD port, DWORD errorFlags);
typedef void (* RS232OnRxTx_fdef)(DWORD port, BYTE buffer[], DWORD dwSize);

DWORD ICS_RS232Open(DWORD port);
DWORD ICS_RS232Close(DWORD port);
DWORD ICS_RS232ConfigTimeout(DWORD port, DWORD baudrate, DWORD numberOfDataBits, DWORD numberOfStopBits, DWORD parity, DWORD timeout);
DWORD ICS_RS232Config(DWORD port, DWORD baudrate, DWORD numberOfDataBits, DWORD numberOfStopBits, DWORD parity);
DWORD ICS_RS232SetHandshake(DWORD port, DWORD handshake, DWORD XonLimit, DWORD XoffLimit, DWORD XonChar, DWORD XoffChar);
DWORD ICS_RS232SetSignalLine(DWORD port, DWORD line, DWORD state);
WORD ICS_RS232WriteByte(DWORD port, DWORD data);
WORD ICS_RS232WriteBlock(DWORD port, BYTE buffer[], DWORD size);
DWORD ICS_RS232Send(DWORD port, BYTE buffer[], DWORD size);
DWORD ICS_RS232Receive(DWORD port, BYTE buffer[], DWORD size);
void ICS_RS232CloseAllPorts();

typedef void	(__stdcall *lpOut32)(short, short);
typedef short	(__stdcall *lpInp32)(short);
typedef BOOL	(__stdcall *lpIsInpOutDriverOpen)(void);
void LoadInpOut();
void UnloadInpout();

int Spy_TextAPI_W(wchar_t * wcCommand, wchar_t * wcResponse, int iResponseMaxLength);
int Spy_TextAPI(char * szCommand, char * szResponse, int iResponseMaxLength);

#define CM_CALLBACKTYPE_APP_SIGNAL                     0
#define CM_CALLBACKTYPE_MESSAGE                        1
#define CM_CALLBACKTYPE_TIMER                          2
#define CM_CALLBACKTYPE_MESSAGE_MG                     3
#define CM_CALLBACKTYPE_MESSAGE_TX                     4

#define CM_GETSET_SET_APP_SIGNAL                       0
#define CM_GETSET_GET_APP_SIGNAL                       1
#define CM_GETSET_SET_TMR_VALUE                        2
#define CM_GETSET_GET_TMR_VALUE                        3
#define CM_GETSET_SET_TMR_ENABLE                       4
#define CM_GETSET_GET_TMR_ENABLE                       5
#define CM_GETSET_FBLOCK_START                         6
#define CM_GETSET_FBLOCK_STOP                          7
#define CM_GETSET_FBLOCK_TRIGGER                       8
#define CM_GETSET_FBLOCK_SAVE                          9
#define CM_GETSET_FBLOCK_GET_ISRUNNING                10
#define CM_GETSET_FBLOCK_GET_ISTRIGGERED              11
#define CM_GETSET_FBLOCK_GET_NUMCOLLECTED             12
#define CM_GETSET_MSG_STATS_CLR                       13
#define CM_GETSET_DB_STATS_CLR                        14
#define CM_GETSET_TX_STATS_CLR                        15
#define CM_GETSET_NET_STATS_CLR                       16
#define CM_GETSET_NODE_STATS_CLR                      17
#define CM_GETSET_MSG_STATS_GET                       18
#define CM_GETSET_DB_STATS_GET                        19
#define CM_GETSET_TX_STATS_GET                        20
#define CM_GETSET_NET_STATS_GET                       21
#define CM_GETSET_NODE_STATS_GET                      22
#define CM_GETSET_SET_APP_SIGNAL_TEXT                 23
#define CM_GETSET_GET_APP_SIGNAL_TEXT                 24
#define CM_GETSET_DB_DLC_GET                          25
#define CM_GETSET_DB_NETWORK_GET                      26
#define CM_GETSET_DB_PERIOD_GET                       27
#define CM_GETSET_MSG_DLC_GET                         28
#define CM_GETSET_MSG_NETWORK_GET                     29
#define CM_GETSET_MSG_PERIOD_GET                      30
#define CM_GETSET_TX_DLC_GET                          31
#define CM_GETSET_TX_NETWORK_GET                      32
#define CM_GETSET_TX_PERIOD_GET                       33
#define CM_GETSET_SPY_LOCK                            34
#define CM_GETSET_SPY_UNLOCK                          35
#define CM_GETSET_DIAG_JOB_ISRUNNING                  36
#define CM_GETSET_DIAG_JOB_NumMessagesCollected       37
#define CM_GETSET_DIAG_JOB_Successful                 38
#define CM_GETSET_DIAG_JOB_ECUResponseCount           39
#define CM_GETSET_DIAG_JOB_TotalTimeAbs               40
#define CM_GETSET_DIAG_JOB_Last7FSubFunctionEx78      41
#define CM_GETSET_DIAG_JOB_7FCountEx78                42
#define CM_GETSET_DIAG_JOB_7FCountResponsePending     43
#define CM_GETSET_DIAGJOB_START                       44
#define CM_GETSET_DIAGJOB_STOP                        45
#define CM_GETSET_DIAGJOB_SAVE                        46
#define CM_GETSET_FBLOCK_ADD                          47
#define CM_GETSET_FBLOCK_FIND                         48
#define CM_GETSET_FBLOCK_POSTTRIGGER                  49
#define CM_GETSET_SET_TMR_PERIOD                      50
#define CM_GETSET_GET_TMR_TIME_TO_ELAPSE              51
#define CM_GETSET_GET_TIMENS                          52
#define CM_GETSET_SET_CAN_MODE                        53
#define CM_GETSET_SET_BTR                             54
#define CM_GETSET_STOP_MEASUREMENT                    55
#define CM_GETSET_CLEAR_TRACES                        56
#define CM_GETSET_FBLOCK_PAUSE                        57
#define CM_GETSET_FBLOCK_CONTINUE                     58
#define CM_GETSET_SYS_EXIT                            59
#define CM_GETSET_SYS_MINIMIZE                        60
#define CM_GETSET_GET_DB_NAME                         61
#define CM_GETSET_SET_LIN_WAKEUP_PARMS                62
#define CM_GETSET_SEND_LIN_WAKEUP                     63
#define CM_GETSET_SEND_LIN_SLEEP                      64
#define CM_GETSET_IL_ACTION                           65
#define CM_GETSET_SET_TXSIGNAL                        66
#define CM_GETSET_SET_APP_SIGNAL_AT                   67
#define CM_GETSET_GET_APP_SIGNAL_AT                   68
#define CM_GETSET_SET_APP_SIGNAL_TEXT_AT              69
#define CM_GETSET_GET_APP_SIGNAL_TEXT_AT              70

#define CM_OSEK_GET_TXID                             501
#define CM_OSEK_SET_TXID                             502
#define CM_OSEK_GET_RXID                             503
#define CM_OSEK_SET_RXID                             504
#define CM_OSEK_GET_USEFC                            505
#define CM_OSEK_SET_USEFC                            506
#define CM_OSEK_SET_0PADDING                         507
#define CM_OSEK_GET_USEEXTID                         508
#define CM_OSEK_SET_USEEXTID                         509
#define CM_OSEK_GET_BS                               510
#define CM_OSEK_SET_BS                               511
#define CM_OSEK_GET_STMIN                            512
#define CM_OSEK_SET_STMIN                            513
#define CM_OSEK_GET_EVAL1FC                          514
#define CM_OSEK_SET_EVAL1FC                          515
#define CM_OSEK_GET_TIMEOUTAR                        516
#define CM_OSEK_SET_TIMEOUTAR                        517
#define CM_OSEK_GET_TIMEOUTAS                        518
#define CM_OSEK_SET_TIMEOUTAS                        519
#define CM_OSEK_GET_TIMEOUTBR                        520
#define CM_OSEK_SET_TIMEOUTBR                        521
#define CM_OSEK_GET_TIMEOUTBS                        522
#define CM_OSEK_SET_TIMEOUTBS                        523
#define CM_OSEK_GET_TIMEOUTCR                        524
#define CM_OSEK_SET_TIMEOUTCR                        525
#define CM_OSEK_GET_1FCBS                            526
#define CM_OSEK_SET_1FCBS                            527
#define CM_OSEK_SET_FIXEDST                          528
#define CM_OSEK_GET_0PATTERN                         529
#define CM_OSEK_SET_0PATTERN                         530
#define CM_OSEK_GET_STARTSN                          531
#define CM_OSEK_SET_STARTSN                          532
#define CM_OSEK_GET_IDFROMADR                        533
#define CM_OSEK_SET_IDFROMADR                        534
#define CM_OSEK_GET_ADRFROMID                        535
#define CM_OSEK_SET_ADRFROMID                        536
#define CM_OSEK_GET_TPBASEADR                        537
#define CM_OSEK_SET_TPBASEADR                        538
#define CM_OSEK_GET_MAXMSGLEN                        539
#define CM_OSEK_SET_MAXMSGLEN                        540
#define CM_OSEK_SET_FCDELAY                          541
#define CM_OSEK_SET_WFTMAX                           542
#define CM_OSEK_GET_DATAREQ                          543
#define CM_OSEK_GET_RXDATA                           544
#define CM_OSEK_GET_SRCADR                           545
#define CM_OSEK_GET_NMSTATUS                         546
#define CM_OSEK_SET_NMSTATUS                         547
#define CM_OSEK_GET_NMCONFIG                         548
#define CM_AUTOSAR_SET_STATUS                        549
#define CM_OSEK_SET_ADDRMODE                         550
#define CM_OSEK_GET_ADDRMODE                         551
#define CM_OSEK_SET_DLCMODE                          552
#define CM_OSEK_SET_CAN                              553
#define CM_OSEK_GET_TGTADR                           554
#define CM_OSEK_SET_TGTADR                           555
#define CM_OSEK_GET_TXMODE                           556
#define CM_OSEK_SET_TXMODE                           557
#define CM_OSEK_SET_MINSTMIN                         558
#define CM_OSEK_GET_ECUNUM                           559
#define CM_OSEK_SET_ECUNUM                           560
#define CM_OSEK_GET_LOFCTADR                         561
#define CM_OSEK_SET_LOFCTADR                         562
#define CM_OSEK_GET_HIFCTADR                         563
#define CM_OSEK_SET_HIFCTADR                         564
#define CM_OSEK_GET_MSGCOUNT                         565
#define CM_OSEK_SET_MSGCOUNT                         566
#define CM_OSEK_GET_TXPRIO                           567
#define CM_OSEK_SET_TXPRIO                           568
#define CM_OSEK_GET_FFPRIO                           569
#define CM_OSEK_SET_FFPRIO                           570
#define CM_OSEK_GET_FCPRIO                           571
#define CM_OSEK_SET_FCPRIO                           572
#define CM_OSEK_GET_USEALLAE                         573
#define CM_OSEK_SET_USEALLAE                         574
#define CM_OSEK_GET_TXTOTHRESHOLD                    575
#define CM_OSEK_SET_TXTOTHRESHOLD                    576
#define CM_OSEK_GET_RECENTAE                         577
#define CM_OSEK_SET_MAXCFBURST                       578
#define CM_OSEK_GET_ADREXT                           579
#define CM_OSEK_SET_ADREXT                           580
#define CM_OSEK_CONNECTREQ                           581

#define ATTR_LIN_TX_SENDSLAVE                       0x10
#define ATTR_LIN_TX_CLASSIC_CHECKSUM                0x20
#define ATTR_LIN_TX_SEND_BREAK_ONLY                 0x40
#define ATTR_LIN_TX_SEND_HDR_ONLY                   0x80
#define ATTR_ACTIVE_INIT                            0x10
#define ATTR_CAN_29BIT_ID_FRAME                     0x20
#define ATTR_CAN_REMOTE_FRAME                       0x40
#define ATTR_CAN_TX_HIGH_VOLTAGE                    0x80
#define ATTR_ALL_RX_TRANSMIT                           1
#define ATTR_ALL_RX_ERROR                              2
#define ATTR_LIN_RX_MASTER_TX                      0x100
#define ATTR_LIN_RX_SLAVE_TX                       0x200

// Spy_ErrorState iErrorBitfield flags
#define CAN_ERROR_STATUS_ACTIVE                   0x0000
#define CAN_ERROR_STATUS_TXRX_WARNING             0x0001  // EWARN: Transmitter or Receiver in Error State Warning bit
#define CAN_ERROR_STATUS_RX_WARNING               0x0002  // RXWAR: Receiver in Error State Warning bit
#define CAN_ERROR_STATUS_TX_WARNING               0x0004  // TXWAR: Transmitter in Error State Warning bit
#define CAN_ERROR_STATUS_RX_PASSIVE               0x0008  // RXBP: Receiver in Error State Bus Passive bit
#define CAN_ERROR_STATUS_TX_PASSIVE               0x0010  // TXBP: Transmitter in Error State Bus Passive bit
#define CAN_ERROR_STATUS_TX_BUS_OFF               0x0020  // TXBO: Transmitter in Error State Bus Off bit

#define SPY_CTL_PROP_ENABLE                       1
#define SPY_CTL_PROP_SET_BACKGROUND               2
#define SPY_CTL_PROP_SET_FOREGROUND               3
#define SPY_CTL_PROP_SET_CAPTION                  4

struct stCallBackPointers
{
    void * pRegisterCallBack;
    void * pGetSetValueCallBack;
    void * pTransmitMessageCallBack;
    void * pOutputWindowCallBack;
    void * pTextAPICallBack;
    void * pGetSignalValue;
    void * pDecodeSignalValue;
    void * pTransmitMessagesFromSignalValues;
    void * pFindIndexForObjectFromNameCallBack;
    void * pShowPanelCallBack;
    void * pMessageGenericInit;
    void * pGetEcuCount;
    void * pGetMemoryBlockCount;
    void * pGetMemoryBlockInfo;
    void * pGetMemoryBlockData;
    void * pSetMemoryBlockData;
    void * pMessageRawInit;
    void * pSignalPhysicalToRaw;
    void * pTransmitMessagesFromRawSignalValues;
    void * pGetMessageName;
    void * pSetControlProp;
    void * pUpdateMessageSignalsFromBytes;
    void * pUpdateBytesFromSignals;
    void * pUpdateBytesFromRawSignals;
};
extern void (* CM_RegisterCallback) (unsigned int uiHandle, unsigned short iValueType, unsigned short iIndex, void * pCallBackPointer) ;
extern void (* CM_GetSetValue) (unsigned int uiHandle, unsigned short iValueType, unsigned short iIndex, void * pValueToSet) ;
extern int  (* CM_TextAPI) (unsigned int uiHandle, wchar_t * pCommand, wchar_t * pResponse, int iResponseMaxLength) ;
extern int  (* CM_OutputWindow) (unsigned int uiHandle, wchar_t * p_TextToWrite, int iColor, int iLength) ;
extern int  (* CM_TransmitMessage) (unsigned int  uiHandle, int iNetwork,int iID, int iNumDataBytes,int iBitField,unsigned char * p_btData);
extern int  (* CM_GetSignalValue) (unsigned int uiHandle, unsigned short iMessageType, unsigned short iMessageIndex,unsigned short iSignalIndex,void * pValueToSet);
extern int  (* CM_TxFromSignals) (unsigned int uiHandle, unsigned short iMessageType,
                       unsigned short iMessageIndex, unsigned char * bt_DefaultBytes, int iByteCount,
                       int iNetworkIndex, void * pSignalValues,
                       int iNumSignalCount);
extern int  (* CM_TxFromRawSignals) (unsigned int uiHandle, unsigned short iMessageType,
                       unsigned short iMessageIndex, unsigned char * bt_DefaultBytes, int iByteCount,
                       int iNetworkIndex, void * pSignalValues,
                       int iNumSignalCount);
extern int  (* CM_UpdateMessageSignalsFromBytes) (unsigned int uiHandle, unsigned short iMessageType, unsigned short iMessageIndex,
                       unsigned char * p_btData, int iNumDataBytes);
extern int  (* CM_UpdateBytesFromSignals) (unsigned int uiHandle, unsigned short iMessageType, unsigned short iMessageIndex,
                       double * p_dSignals, int dSignalMaxCount, unsigned char * p_btData, int iNumDataBytes);
extern int  (* CM_UpdateBytesFromRawSignals) (unsigned int uiHandle, unsigned short iMessageType, unsigned short iMessageIndex,
                       uint64 * p_iSignals, int dSignalMaxCount, unsigned char * p_btData, int iNumDataBytes);
extern int  (* CM_FindIndexForObjectFromName) (unsigned int uiHandle, int iObjectType,wchar_t * pName, int * p_iObjectIndex);
extern int  (* CM_GetMessageName) (unsigned int uiHandle, int iMessageId, int iMessageContext, wchar_t * pName, int iBufferSize);
extern int  (* CM_ShowPanel) (unsigned int uiHandle, wchar_t * pWindowName, wchar_t * pPanelName);
extern int  (* CM_SetControlProperty) (unsigned int uiHandle, wchar_t * pPanelName, wchar_t * pWindowName, int prop, void *pValue);
extern int  (* CM_MessageGenericInit) (unsigned int uiHandle, unsigned short iMessageType,
                       unsigned short iMessageIndex, void * p_MessageStats, int * p_iNetworkID,
                       int * p_iNumDataBytes, int  p_iNumDataMax, int * p_iPeriodMs, int * p_iID,
                       int * p_iBitField, unsigned char * p_btData, double * p_dSignals, int dSignalMaxCount,
                       int * p_iActualSignalMaxCount,__int64 * p_iTimeStampNanoSecondsHW,unsigned int * p_iTimeStampMillisecondsOS);
extern int  (* CM_MessageRawInit) (unsigned int uiHandle, unsigned short iMessageType, unsigned short iMessageIndex,
                       uint64 * p_dSignals, int dSignalMaxCount, int * p_iActualSignalMaxCount);
extern uint64 (* CM_SignalPhysicalToRaw) (unsigned int uiHandle, unsigned short iMessageType, unsigned short iMessageIndex,
                       unsigned short iSignalIndex, double dPhysicalValue);
extern int  (* CM_GetEcuCount) (unsigned int uiHandle);
extern int  (* CM_GetMemoryBlockCount) (unsigned int uiHandle, int ecu);
extern int  (* CM_GetMemoryBlockInfo) (unsigned int uiHandle, int ecu, int block, unsigned int *address, unsigned int *size);
extern int  (* CM_GetMemoryBlockData) (unsigned int uiHandle, int ecu, int block, unsigned char *buffer, unsigned int address, unsigned int size);
extern int  (* CM_SetMemoryBlockData) (unsigned int uiHandle, int ecu, int block, unsigned char *buffer, unsigned int address, unsigned int size);

#define CAN_ID_EXTENDED_BIT   0x80000000
#define isStdId(id) ((id & CAN_ID_EXTENDED_BIT) == 0)
#define isExtId(id) ((id & CAN_ID_EXTENDED_BIT) == CAN_ID_EXTENDED_BIT)
#define mkExtId(id) (id | CAN_ID_EXTENDED_BIT)
#define mkStdId(id) (id & (~CAN_ID_EXTENDED_BIT))
#define valOfId(id) ((long)id)
void SetUseExtendedIdBit();

#define GMLAN_SOURCE_MASK 0xff
#define GMLAN_PID_MASK    0xffff
#define GMLAND_PID_SHIFT  8
#define GMLAN_PRIO_MASK   0x07
#define GMLAND_PRIO_SHIFT 26
#define gmlanSetSourceId(id, source) (id |= (source & GMLAN_SOURCE_MASK))
#define gmlanSetPid(id, pid) (id |= ((pid & GMLAN_PID_MASK) << GMLAND_PID_SHIFT))
#define gmlanSetPrio(id, prio) (id |= ((prio & GMLAN_PRIO_MASK) << GMLAND_PRIO_SHIFT))
#define gmlanGetSourceId(id) (id & GMLAN_SOURCE_MASK)
#define gmlanGetPid(id) ((id >> GMLAND_PID_SHIFT) & GMLAN_PID_MASK)
#define gmlanGetPrio(id) ((id >> GMLAND_PRIO_SHIFT) & GMLAN_PRIO_MASK)
#define gmlanId(id, source) (id | (source & GMLAN_SOURCE_MASK))

int getStartDelay();
void setStartDelay(int delay);

void SpyShowPanel(char * pWindowName, char * pPanelName);
void SpyShowPanelW(wchar_t * pWindowName, wchar_t * pPanelName);
void SpySetControlProperty(char * pPanelName, char * pControlTag, int prop, void *pValue);
void SpySetControlPropertyW(wchar_t * pPanelName, wchar_t * pControlTag, int prop, void *pValue);
void Spy_Lock();
void Spy_Unlock();
int GetMessageName(int iMessageId, int iMessageContext, char * pName, int iBufferSize);
int GetMessageNameW(int iMessageId, int iMessageContext, wchar_t * pName, int iBufferSize);
double AS_Get(int index);
void AS_Set(int index, double dValue);
double AS_GetAt(int index, int element);
void AS_SetAt(int index, int element, double dValue);
int AS_GetText(int nIndex, void * szValue, int nLength);
int AS_SetText(int nIndex, void * szValue, int nLength);
int AS_GetTextW(int index, wchar_t * szValue);
void SpySetTxSignal(unsigned int iMessageIndex, unsigned int iSignalIndex, double dValue);
void SpySetTxSignalRaw(unsigned int iMessageIndex, unsigned int iSignalIndex, __int64 nValue);
void SpySetTxEvent(unsigned int iMessageIndex);
int AS_GetTextAtW(int index, int element, wchar_t * szValue);
int AS_SetTextAtW(int index, int element, wchar_t * szValue);

typedef struct {
    unsigned int iSignal;    /// signal to set
    unsigned int iType;      /// 0 physical, 1 raw
    union {
        double dValue;           /// value 
        __int64 nValue;
    };
} TxSetSignal;

// Network Statistics
typedef struct {
    unsigned int iCount;  /// count of messages on network
    unsigned int iRate; /// messages per second
    double dPercentUse; /// current bus utilization 
    unsigned int iMaxRate;    /// maximum messages per second
    double dMaxPercentUse;   /// maximum bus utilization
    unsigned int iErrorCount;   /// number of errors on a network
    unsigned int iTxCount;       /// number of messages transmitted on a network
    unsigned int iErrorRate; /// errors per second
    unsigned int iTxRate;        /// transmissions per second
    unsigned int iTxBufferFill;  /// current network buffer fill level
    unsigned int iCANTxErrCount;  /// transmit CAN errors
    unsigned int iCANRxErrCount;  /// receive CAN errors
} NetworkStats; 
int Spy_TranslateNetwork(int nNetworkOffset);
int Spy_UntranslateNetwork(int nNetwork);
int Spy_NetworksInUse();
int Spy_LINIndex(int iNetwork);

// network index variables - identify networks in vspy
extern int NET_HS_CAN;
void NET_HS_CAN_ClearStats();
void NET_HS_CAN_GetStats(NetworkStats * p_NetworkStats);
extern int NET_MS_CAN;
void NET_MS_CAN_ClearStats();
void NET_MS_CAN_GetStats(NetworkStats * p_NetworkStats);
extern int NET_SW_CAN;
void NET_SW_CAN_ClearStats();
void NET_SW_CAN_GetStats(NetworkStats * p_NetworkStats);
extern int NET_J1850_VPW;
void NET_J1850_VPW_ClearStats();
void NET_J1850_VPW_GetStats(NetworkStats * p_NetworkStats);
extern int NET_ISO9141_KW2K;
void NET_ISO9141_KW2K_ClearStats();
void NET_ISO9141_KW2K_GetStats(NetworkStats * p_NetworkStats);
extern int NET_LSFT_CAN;
void NET_LSFT_CAN_ClearStats();
void NET_LSFT_CAN_GetStats(NetworkStats * p_NetworkStats);
extern int NET_J1850_PWM;
void NET_J1850_PWM_ClearStats();
void NET_J1850_PWM_GetStats(NetworkStats * p_NetworkStats);
extern int NET_J1708;
void NET_J1708_ClearStats();
void NET_J1708_GetStats(NetworkStats * p_NetworkStats);
extern int NET_neoVI;
void NET_neoVI_ClearStats();
void NET_neoVI_GetStats(NetworkStats * p_NetworkStats);

void SpyAppSig_CallAllHandlers();

// Application Signals

// Messages

typedef struct {
    unsigned char btPresent;  /// indicates message rxed at least once
    unsigned char  btPresentToggle; /// toggle every message rx
    unsigned char         btMultiFrameComplete; /// indicates frame is complete 
    double dUpdateRateRel;    /// periodic update rate
    double dUpdateRateAbs ;   /// absolute update rate
    int iPerSecond;   /// number of messages per second
    int iCount;       /// number of messages rxed
    int iChangeCount; /// count of everytime the message changes
    double dStartTime;        /// time between two first messages
    double dMsgMinTime;       /// min time between two messages
    double dMaxTime;          /// max time between two messages
    double dMeanTime;         /// average time between two messages
} MessageStats; 

typedef struct {
    int iNetwork; /// Network in Vehicle Spy
    int iID; /// Message ID
    __int64 iTimeStampNanoSecondsHW; /// TimeStamp By Hardware (3G Hardware Only)
    unsigned int iTimeStampMillisecondsOS; /// TimeStamp By OS (timeGetTime API)
    int iNumDataBytes; /// Number Of Data Bytes (CAN DLC)
    int iBitField;
    unsigned char btData[16]; /// Message data bytes
    unsigned char btInitialData[16]; /// Data bytes after initialization
} GenericMessage;

typedef struct {
    int iNetwork; /// Network in Vehicle Spy
    int iID; /// Message ID
    __int64 iTimeStampNanoSecondsHW; /// TimeStamp By Hardware (3G Hardware Only)
    unsigned int iTimeStampMillisecondsOS; /// TimeStamp By OS (timeGetTime API)
    int iNumDataBytes; /// Number Of Data Bytes (CAN DLC)
    int iBitField;
    unsigned char btData[4096]; /// Message data bytes
    unsigned char btInitialData[4096]; /// Data bytes after initialization
} GenericLongMessage;

void Spy_EveryMessage(GenericMessage * p_Msg);
int GenericMessageTransmit(GenericMessage * p_Msg);
extern int TX_ECU_To_Tester_HS_CAN_Index;
typedef struct {
    GenericMessage MessageData; /// Message Data
    MessageStats Statistics; /// Message Statistics
    int iDefaultPeriodMilliseconds; /// Default Message Period
} TX_ECU_To_Tester_HS_CAN;


void TX_ECU_To_Tester_HS_CAN_Init(TX_ECU_To_Tester_HS_CAN * pMsg);
int TX_ECU_To_Tester_HS_CAN_Transmit(TX_ECU_To_Tester_HS_CAN * pMsg);
int TX_ECU_To_Tester_HS_CAN_Transmit_raw(TX_ECU_To_Tester_HS_CAN * pMsg);
int TX_ECU_To_Tester_HS_CAN_TransmitFast();
void TX_ECU_To_Tester_HS_CAN_ClearStats();
extern int MG_TesterToECU_HS_CAN_Index;
typedef struct {
    GenericMessage MessageData; /// Message Data
    MessageStats Statistics; /// Message Statistics
    int iDefaultPeriodMilliseconds; /// Default Message Period
} MG_TesterToECU_HS_CAN;


void MG_TesterToECU_HS_CAN_Init(MG_TesterToECU_HS_CAN * pMsg);
int MG_TesterToECU_HS_CAN_Transmit(MG_TesterToECU_HS_CAN * pMsg);
int MG_TesterToECU_HS_CAN_Transmit_raw(MG_TesterToECU_HS_CAN * pMsg);
void MG_TesterToECU_HS_CAN_ClearStats();
extern int DB_Report_Message_neoVI_Index;
typedef struct {
    GenericMessage MessageData; /// Message Data
    MessageStats Statistics; /// Message Statistics
    int iDefaultPeriodMilliseconds; /// Default Message Period
    double MISC3_AIN; /// Min: 0 Max: 1023 Units: 
    BYTE MISC3_AIN_raw;
    double MISC4_AIN; /// Min: 0 Max: 1023 Units: 
    BYTE MISC4_AIN_raw;
    double MISC5_AIN; /// Min: 0 Max: 1023 Units: 
    BYTE MISC5_AIN_raw;
    double MISC6_AIN; /// Min: 0 Max: 1023 Units: 
    BYTE MISC6_AIN_raw;
    double MISC1; /// Min: 0 Max: 1 Units: 
    BYTE MISC1_raw;
    double MISC2; /// Min: 0 Max: 1 Units: 
    BYTE MISC2_raw;
    double MISC3; /// Min: 0 Max: 1 Units: 
    BYTE MISC3_raw;
    double MISC4; /// Min: 0 Max: 1 Units: 
    BYTE MISC4_raw;
    double MISC5; /// Min: 0 Max: 1 Units: 
    BYTE MISC5_raw;
    double MISC6; /// Min: 0 Max: 1 Units: 
    BYTE MISC6_raw;
    double LED1; /// Min: 0 Max: 1 Units: 
    BYTE LED1_raw;
    double LED2; /// Min: 0 Max: 1 Units: 
    BYTE LED2_raw;
    double LIN1; /// Min: 0 Max: 1 Units: 
    BYTE LIN1_raw;
    double LIN2; /// Min: 0 Max: 1 Units: 
    BYTE LIN2_raw;
} DB_Report_Message_neoVI;


void DB_Report_Message_neoVI_Init(DB_Report_Message_neoVI * pMsg);
int DB_Report_Message_neoVI_Transmit(DB_Report_Message_neoVI * pMsg);
int DB_Report_Message_neoVI_Transmit_raw(DB_Report_Message_neoVI * pMsg);
int DB_Report_Message_neoVI_UpdateBytesFromSignals(DB_Report_Message_neoVI * pMsg);
int DB_Report_Message_neoVI_UpdateBytesFromRawSignals(DB_Report_Message_neoVI * pMsg);

BYTE DB_Report_Message_neoVI_MISC3_AIN_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message_neoVI_MISC4_AIN_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message_neoVI_MISC5_AIN_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message_neoVI_MISC6_AIN_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message_neoVI_MISC1_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message_neoVI_MISC2_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message_neoVI_MISC3_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message_neoVI_MISC4_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message_neoVI_MISC5_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message_neoVI_MISC6_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message_neoVI_LED1_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message_neoVI_LED2_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message_neoVI_LIN1_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message_neoVI_LIN2_PhysicalToRaw(double dPhysicalValue);
void DB_Report_Message_neoVI_ClearStats();
extern int DB_Report_Message__PWM__neoVI_Index;
typedef struct {
    GenericMessage MessageData; /// Message Data
    MessageStats Statistics; /// Message Statistics
    int iDefaultPeriodMilliseconds; /// Default Message Period
    double PWM_In_1; /// Min: 0 Max: 4294967295 Units: 
    BYTE PWM_In_1_raw;
} DB_Report_Message__PWM__neoVI;


void DB_Report_Message__PWM__neoVI_Init(DB_Report_Message__PWM__neoVI * pMsg);
int DB_Report_Message__PWM__neoVI_Transmit(DB_Report_Message__PWM__neoVI * pMsg);
int DB_Report_Message__PWM__neoVI_Transmit_raw(DB_Report_Message__PWM__neoVI * pMsg);
int DB_Report_Message__PWM__neoVI_UpdateBytesFromSignals(DB_Report_Message__PWM__neoVI * pMsg);
int DB_Report_Message__PWM__neoVI_UpdateBytesFromRawSignals(DB_Report_Message__PWM__neoVI * pMsg);

BYTE DB_Report_Message__PWM__neoVI_PWM_In_1_PhysicalToRaw(double dPhysicalValue);
void DB_Report_Message__PWM__neoVI_ClearStats();
extern int DB_Report_Message__GPS_Latitude__neoVI_Index;
typedef struct {
    GenericMessage MessageData; /// Message Data
    MessageStats Statistics; /// Message Statistics
    int iDefaultPeriodMilliseconds; /// Default Message Period
    double Latitude; /// Min: 0 Max: 0 Units: degrees
    BYTE Latitude_raw;
} DB_Report_Message__GPS_Latitude__neoVI;


void DB_Report_Message__GPS_Latitude__neoVI_Init(DB_Report_Message__GPS_Latitude__neoVI * pMsg);
int DB_Report_Message__GPS_Latitude__neoVI_Transmit(DB_Report_Message__GPS_Latitude__neoVI * pMsg);
int DB_Report_Message__GPS_Latitude__neoVI_Transmit_raw(DB_Report_Message__GPS_Latitude__neoVI * pMsg);
int DB_Report_Message__GPS_Latitude__neoVI_UpdateBytesFromSignals(DB_Report_Message__GPS_Latitude__neoVI * pMsg);
int DB_Report_Message__GPS_Latitude__neoVI_UpdateBytesFromRawSignals(DB_Report_Message__GPS_Latitude__neoVI * pMsg);

BYTE DB_Report_Message__GPS_Latitude__neoVI_Latitude_PhysicalToRaw(double dPhysicalValue);
void DB_Report_Message__GPS_Latitude__neoVI_ClearStats();
extern int DB_Report_Message__GPS_Longitude__neoVI_Index;
typedef struct {
    GenericMessage MessageData; /// Message Data
    MessageStats Statistics; /// Message Statistics
    int iDefaultPeriodMilliseconds; /// Default Message Period
    double Longitude; /// Min: 0 Max: 0 Units: degrees
    BYTE Longitude_raw;
} DB_Report_Message__GPS_Longitude__neoVI;


void DB_Report_Message__GPS_Longitude__neoVI_Init(DB_Report_Message__GPS_Longitude__neoVI * pMsg);
int DB_Report_Message__GPS_Longitude__neoVI_Transmit(DB_Report_Message__GPS_Longitude__neoVI * pMsg);
int DB_Report_Message__GPS_Longitude__neoVI_Transmit_raw(DB_Report_Message__GPS_Longitude__neoVI * pMsg);
int DB_Report_Message__GPS_Longitude__neoVI_UpdateBytesFromSignals(DB_Report_Message__GPS_Longitude__neoVI * pMsg);
int DB_Report_Message__GPS_Longitude__neoVI_UpdateBytesFromRawSignals(DB_Report_Message__GPS_Longitude__neoVI * pMsg);

BYTE DB_Report_Message__GPS_Longitude__neoVI_Longitude_PhysicalToRaw(double dPhysicalValue);
void DB_Report_Message__GPS_Longitude__neoVI_ClearStats();
extern int DB_Report_Message__GPS_Flags__neoVI_Index;
typedef struct {
    GenericMessage MessageData; /// Message Data
    MessageStats Statistics; /// Message Statistics
    int iDefaultPeriodMilliseconds; /// Default Message Period
    double Update_Count; /// Min: 0 Max: 0 Units: 
    BYTE Update_Count_raw;
    double GPS_Date_Available; /// Min: 0 Max: 0 Units: 
    BYTE GPS_Date_Available_raw;
    double GPS_Time_Available; /// Min: 0 Max: 0 Units: 
    BYTE GPS_Time_Available_raw;
    double GPS_Accuracy_Available; /// Min: 0 Max: 0 Units: 
    BYTE GPS_Accuracy_Available_raw;
    double GPS_Bearing_Available; /// Min: 0 Max: 0 Units: 
    BYTE GPS_Bearing_Available_raw;
    double GPS_Speed_Available; /// Min: 0 Max: 0 Units: 
    BYTE GPS_Speed_Available_raw;
    double GPS_Altitude_Available; /// Min: 0 Max: 0 Units: 
    BYTE GPS_Altitude_Available_raw;
    double GPS_Lat_Lon_Available; /// Min: 0 Max: 0 Units: 
    BYTE GPS_Lat_Lon_Available_raw;
} DB_Report_Message__GPS_Flags__neoVI;


void DB_Report_Message__GPS_Flags__neoVI_Init(DB_Report_Message__GPS_Flags__neoVI * pMsg);
int DB_Report_Message__GPS_Flags__neoVI_Transmit(DB_Report_Message__GPS_Flags__neoVI * pMsg);
int DB_Report_Message__GPS_Flags__neoVI_Transmit_raw(DB_Report_Message__GPS_Flags__neoVI * pMsg);
int DB_Report_Message__GPS_Flags__neoVI_UpdateBytesFromSignals(DB_Report_Message__GPS_Flags__neoVI * pMsg);
int DB_Report_Message__GPS_Flags__neoVI_UpdateBytesFromRawSignals(DB_Report_Message__GPS_Flags__neoVI * pMsg);

BYTE DB_Report_Message__GPS_Flags__neoVI_Update_Count_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message__GPS_Flags__neoVI_GPS_Date_Available_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message__GPS_Flags__neoVI_GPS_Time_Available_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message__GPS_Flags__neoVI_GPS_Accuracy_Available_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message__GPS_Flags__neoVI_GPS_Bearing_Available_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message__GPS_Flags__neoVI_GPS_Speed_Available_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message__GPS_Flags__neoVI_GPS_Altitude_Available_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message__GPS_Flags__neoVI_GPS_Lat_Lon_Available_PhysicalToRaw(double dPhysicalValue);
void DB_Report_Message__GPS_Flags__neoVI_ClearStats();
extern int DB_Report_Message__GPS_Altitude__neoVI_Index;
typedef struct {
    GenericMessage MessageData; /// Message Data
    MessageStats Statistics; /// Message Statistics
    int iDefaultPeriodMilliseconds; /// Default Message Period
    double Altitude_Ellipse; /// Min: 0 Max: 0 Units: meters
    BYTE Altitude_Ellipse_raw;
} DB_Report_Message__GPS_Altitude__neoVI;


void DB_Report_Message__GPS_Altitude__neoVI_Init(DB_Report_Message__GPS_Altitude__neoVI * pMsg);
int DB_Report_Message__GPS_Altitude__neoVI_Transmit(DB_Report_Message__GPS_Altitude__neoVI * pMsg);
int DB_Report_Message__GPS_Altitude__neoVI_Transmit_raw(DB_Report_Message__GPS_Altitude__neoVI * pMsg);
int DB_Report_Message__GPS_Altitude__neoVI_UpdateBytesFromSignals(DB_Report_Message__GPS_Altitude__neoVI * pMsg);
int DB_Report_Message__GPS_Altitude__neoVI_UpdateBytesFromRawSignals(DB_Report_Message__GPS_Altitude__neoVI * pMsg);

BYTE DB_Report_Message__GPS_Altitude__neoVI_Altitude_Ellipse_PhysicalToRaw(double dPhysicalValue);
void DB_Report_Message__GPS_Altitude__neoVI_ClearStats();
extern int DB_Report_Message__GPS_Speed_Bearing__neoVI_Index;
typedef struct {
    GenericMessage MessageData; /// Message Data
    MessageStats Statistics; /// Message Statistics
    int iDefaultPeriodMilliseconds; /// Default Message Period
    double Speed; /// Min: 0 Max: 0 Units: m/s
    BYTE Speed_raw;
    double Bearing; /// Min: 0 Max: 0 Units: degrees
    BYTE Bearing_raw;
} DB_Report_Message__GPS_Speed_Bearing__neoVI;


void DB_Report_Message__GPS_Speed_Bearing__neoVI_Init(DB_Report_Message__GPS_Speed_Bearing__neoVI * pMsg);
int DB_Report_Message__GPS_Speed_Bearing__neoVI_Transmit(DB_Report_Message__GPS_Speed_Bearing__neoVI * pMsg);
int DB_Report_Message__GPS_Speed_Bearing__neoVI_Transmit_raw(DB_Report_Message__GPS_Speed_Bearing__neoVI * pMsg);
int DB_Report_Message__GPS_Speed_Bearing__neoVI_UpdateBytesFromSignals(DB_Report_Message__GPS_Speed_Bearing__neoVI * pMsg);
int DB_Report_Message__GPS_Speed_Bearing__neoVI_UpdateBytesFromRawSignals(DB_Report_Message__GPS_Speed_Bearing__neoVI * pMsg);

BYTE DB_Report_Message__GPS_Speed_Bearing__neoVI_Speed_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message__GPS_Speed_Bearing__neoVI_Bearing_PhysicalToRaw(double dPhysicalValue);
void DB_Report_Message__GPS_Speed_Bearing__neoVI_ClearStats();
extern int DB_Report_Message__GPS_Accuracy__neoVI_Index;
typedef struct {
    GenericMessage MessageData; /// Message Data
    MessageStats Statistics; /// Message Statistics
    int iDefaultPeriodMilliseconds; /// Default Message Period
    double Accuracy; /// Min: 0 Max: 0 Units: meters
    BYTE Accuracy_raw;
} DB_Report_Message__GPS_Accuracy__neoVI;


void DB_Report_Message__GPS_Accuracy__neoVI_Init(DB_Report_Message__GPS_Accuracy__neoVI * pMsg);
int DB_Report_Message__GPS_Accuracy__neoVI_Transmit(DB_Report_Message__GPS_Accuracy__neoVI * pMsg);
int DB_Report_Message__GPS_Accuracy__neoVI_Transmit_raw(DB_Report_Message__GPS_Accuracy__neoVI * pMsg);
int DB_Report_Message__GPS_Accuracy__neoVI_UpdateBytesFromSignals(DB_Report_Message__GPS_Accuracy__neoVI * pMsg);
int DB_Report_Message__GPS_Accuracy__neoVI_UpdateBytesFromRawSignals(DB_Report_Message__GPS_Accuracy__neoVI * pMsg);

BYTE DB_Report_Message__GPS_Accuracy__neoVI_Accuracy_PhysicalToRaw(double dPhysicalValue);
void DB_Report_Message__GPS_Accuracy__neoVI_ClearStats();
extern int DB_Report_Message__GPS_Time__neoVI_Index;
typedef struct {
    GenericMessage MessageData; /// Message Data
    MessageStats Statistics; /// Message Statistics
    int iDefaultPeriodMilliseconds; /// Default Message Period
    double Timestamp; /// Min: 0 Max: 0 Units: ms since 1/1/1970
    BYTE Timestamp_raw;
} DB_Report_Message__GPS_Time__neoVI;


void DB_Report_Message__GPS_Time__neoVI_Init(DB_Report_Message__GPS_Time__neoVI * pMsg);
int DB_Report_Message__GPS_Time__neoVI_Transmit(DB_Report_Message__GPS_Time__neoVI * pMsg);
int DB_Report_Message__GPS_Time__neoVI_Transmit_raw(DB_Report_Message__GPS_Time__neoVI * pMsg);
int DB_Report_Message__GPS_Time__neoVI_UpdateBytesFromSignals(DB_Report_Message__GPS_Time__neoVI * pMsg);
int DB_Report_Message__GPS_Time__neoVI_UpdateBytesFromRawSignals(DB_Report_Message__GPS_Time__neoVI * pMsg);

BYTE DB_Report_Message__GPS_Time__neoVI_Timestamp_PhysicalToRaw(double dPhysicalValue);
void DB_Report_Message__GPS_Time__neoVI_ClearStats();
extern int DB_Report_Message__WirelessneoVI_Sectors__neoVI_Index;
typedef struct {
    GenericMessage MessageData; /// Message Data
    MessageStats Statistics; /// Message Statistics
    int iDefaultPeriodMilliseconds; /// Default Message Period
    double WiviStartSector; /// Min: 0 Max: 0 Units: 
    BYTE WiviStartSector_raw;
    double WiviEndSector; /// Min: 0 Max: 0 Units: 
    BYTE WiviEndSector_raw;
} DB_Report_Message__WirelessneoVI_Sectors__neoVI;


void DB_Report_Message__WirelessneoVI_Sectors__neoVI_Init(DB_Report_Message__WirelessneoVI_Sectors__neoVI * pMsg);
int DB_Report_Message__WirelessneoVI_Sectors__neoVI_Transmit(DB_Report_Message__WirelessneoVI_Sectors__neoVI * pMsg);
int DB_Report_Message__WirelessneoVI_Sectors__neoVI_Transmit_raw(DB_Report_Message__WirelessneoVI_Sectors__neoVI * pMsg);
int DB_Report_Message__WirelessneoVI_Sectors__neoVI_UpdateBytesFromSignals(DB_Report_Message__WirelessneoVI_Sectors__neoVI * pMsg);
int DB_Report_Message__WirelessneoVI_Sectors__neoVI_UpdateBytesFromRawSignals(DB_Report_Message__WirelessneoVI_Sectors__neoVI * pMsg);

BYTE DB_Report_Message__WirelessneoVI_Sectors__neoVI_WiviStartSector_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message__WirelessneoVI_Sectors__neoVI_WiviEndSector_PhysicalToRaw(double dPhysicalValue);
void DB_Report_Message__WirelessneoVI_Sectors__neoVI_ClearStats();
extern int DB_Report_Message__WirelessneoVI_Signals__neoVI_Index;
typedef struct {
    GenericMessage MessageData; /// Message Data
    MessageStats Statistics; /// Message Statistics
    int iDefaultPeriodMilliseconds; /// Default Message Period
    double WiviJob; /// Min: 0 Max: 0 Units: 
    BYTE WiviJob_raw;
    double WiviApkResponse; /// Min: 0 Max: 0 Units: 
    BYTE WiviApkResponse_raw;
    double WiviDataTransferMediumChoice; /// Min: 0 Max: 0 Units: 
    BYTE WiviDataTransferMediumChoice_raw;
    double WiviApkResponseTo; /// Min: 0 Max: 0 Units: 
    BYTE WiviApkResponseTo_raw;
    double WiviReserved0; /// Min: 0 Max: 0 Units: 
    BYTE WiviReserved0_raw;
    double WiviReserved1; /// Min: 0 Max: 0 Units: 
    BYTE WiviReserved1_raw;
} DB_Report_Message__WirelessneoVI_Signals__neoVI;


void DB_Report_Message__WirelessneoVI_Signals__neoVI_Init(DB_Report_Message__WirelessneoVI_Signals__neoVI * pMsg);
int DB_Report_Message__WirelessneoVI_Signals__neoVI_Transmit(DB_Report_Message__WirelessneoVI_Signals__neoVI * pMsg);
int DB_Report_Message__WirelessneoVI_Signals__neoVI_Transmit_raw(DB_Report_Message__WirelessneoVI_Signals__neoVI * pMsg);
int DB_Report_Message__WirelessneoVI_Signals__neoVI_UpdateBytesFromSignals(DB_Report_Message__WirelessneoVI_Signals__neoVI * pMsg);
int DB_Report_Message__WirelessneoVI_Signals__neoVI_UpdateBytesFromRawSignals(DB_Report_Message__WirelessneoVI_Signals__neoVI * pMsg);

BYTE DB_Report_Message__WirelessneoVI_Signals__neoVI_WiviJob_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message__WirelessneoVI_Signals__neoVI_WiviApkResponse_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message__WirelessneoVI_Signals__neoVI_WiviDataTransferMediumChoice_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message__WirelessneoVI_Signals__neoVI_WiviApkResponseTo_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message__WirelessneoVI_Signals__neoVI_WiviReserved0_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message__WirelessneoVI_Signals__neoVI_WiviReserved1_PhysicalToRaw(double dPhysicalValue);
void DB_Report_Message__WirelessneoVI_Signals__neoVI_ClearStats();
extern int DB_Report_Message_1_Analog_Card__neoVI_Index;
typedef struct {
    GenericMessage MessageData; /// Message Data
    MessageStats Statistics; /// Message Statistics
    int iDefaultPeriodMilliseconds; /// Default Message Period
    double Channel_A; /// Min: 0 Max: 0 Units: mV
    BYTE Channel_A_raw;
    double Channel_B; /// Min: 0 Max: 0 Units: mV
    BYTE Channel_B_raw;
    double Channel_1_Differential_; /// Min: 0 Max: 0 Units: mV
    BYTE Channel_1_Differential__raw;
    double Channel_2_Differential_; /// Min: 0 Max: 0 Units: mV
    uint64 Channel_2_Differential__raw;
} DB_Report_Message_1_Analog_Card__neoVI;


void DB_Report_Message_1_Analog_Card__neoVI_Init(DB_Report_Message_1_Analog_Card__neoVI * pMsg);
int DB_Report_Message_1_Analog_Card__neoVI_Transmit(DB_Report_Message_1_Analog_Card__neoVI * pMsg);
int DB_Report_Message_1_Analog_Card__neoVI_Transmit_raw(DB_Report_Message_1_Analog_Card__neoVI * pMsg);
int DB_Report_Message_1_Analog_Card__neoVI_UpdateBytesFromSignals(DB_Report_Message_1_Analog_Card__neoVI * pMsg);
int DB_Report_Message_1_Analog_Card__neoVI_UpdateBytesFromRawSignals(DB_Report_Message_1_Analog_Card__neoVI * pMsg);

BYTE DB_Report_Message_1_Analog_Card__neoVI_Channel_A_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message_1_Analog_Card__neoVI_Channel_B_PhysicalToRaw(double dPhysicalValue);

BYTE DB_Report_Message_1_Analog_Card__neoVI_Channel_1_Differential__PhysicalToRaw(double dPhysicalValue);

uint64 DB_Report_Message_1_Analog_Card__neoVI_Channel_2_Differential__PhysicalToRaw(double dPhysicalValue);
void DB_Report_Message_1_Analog_Card__neoVI_ClearStats();
extern int DB_Report_Message_2_Analog_Card__neoVI_Index;
typedef struct {
    GenericMessage MessageData; /// Message Data
    MessageStats Statistics; /// Message Statistics
    int iDefaultPeriodMilliseconds; /// Default Message Period
    double Channel_3_Differential_; /// Min: 0 Max: 0 Units: mV
    uint64 Channel_3_Differential__raw;
    double Channel_4_Differential_; /// Min: 0 Max: 0 Units: mV
    uint64 Channel_4_Differential__raw;
    double Channel_5_Differential_; /// Min: 0 Max: 0 Units: mV
    uint64 Channel_5_Differential__raw;
    double Channel_6_Differential_; /// Min: 0 Max: 0 Units: mV
    uint64 Channel_6_Differential__raw;
} DB_Report_Message_2_Analog_Card__neoVI;


void DB_Report_Message_2_Analog_Card__neoVI_Init(DB_Report_Message_2_Analog_Card__neoVI * pMsg);
int DB_Report_Message_2_Analog_Card__neoVI_Transmit(DB_Report_Message_2_Analog_Card__neoVI * pMsg);
int DB_Report_Message_2_Analog_Card__neoVI_Transmit_raw(DB_Report_Message_2_Analog_Card__neoVI * pMsg);
int DB_Report_Message_2_Analog_Card__neoVI_UpdateBytesFromSignals(DB_Report_Message_2_Analog_Card__neoVI * pMsg);
int DB_Report_Message_2_Analog_Card__neoVI_UpdateBytesFromRawSignals(DB_Report_Message_2_Analog_Card__neoVI * pMsg);

uint64 DB_Report_Message_2_Analog_Card__neoVI_Channel_3_Differential__PhysicalToRaw(double dPhysicalValue);

uint64 DB_Report_Message_2_Analog_Card__neoVI_Channel_4_Differential__PhysicalToRaw(double dPhysicalValue);

uint64 DB_Report_Message_2_Analog_Card__neoVI_Channel_5_Differential__PhysicalToRaw(double dPhysicalValue);

uint64 DB_Report_Message_2_Analog_Card__neoVI_Channel_6_Differential__PhysicalToRaw(double dPhysicalValue);
void DB_Report_Message_2_Analog_Card__neoVI_ClearStats();
extern int DB_Report_Message_3_Analog_Card__neoVI_Index;
typedef struct {
    GenericMessage MessageData; /// Message Data
    MessageStats Statistics; /// Message Statistics
    int iDefaultPeriodMilliseconds; /// Default Message Period
    double Channel_7_Differential_; /// Min: 0 Max: 0 Units: mV
    uint64 Channel_7_Differential__raw;
} DB_Report_Message_3_Analog_Card__neoVI;


void DB_Report_Message_3_Analog_Card__neoVI_Init(DB_Report_Message_3_Analog_Card__neoVI * pMsg);
int DB_Report_Message_3_Analog_Card__neoVI_Transmit(DB_Report_Message_3_Analog_Card__neoVI * pMsg);
int DB_Report_Message_3_Analog_Card__neoVI_Transmit_raw(DB_Report_Message_3_Analog_Card__neoVI * pMsg);
int DB_Report_Message_3_Analog_Card__neoVI_UpdateBytesFromSignals(DB_Report_Message_3_Analog_Card__neoVI * pMsg);
int DB_Report_Message_3_Analog_Card__neoVI_UpdateBytesFromRawSignals(DB_Report_Message_3_Analog_Card__neoVI * pMsg);

uint64 DB_Report_Message_3_Analog_Card__neoVI_Channel_7_Differential__PhysicalToRaw(double dPhysicalValue);
void DB_Report_Message_3_Analog_Card__neoVI_ClearStats();
extern int DB_Report_Message_4_Analog_Card__neoVI_Index;
typedef struct {
    GenericMessage MessageData; /// Message Data
    MessageStats Statistics; /// Message Statistics
    int iDefaultPeriodMilliseconds; /// Default Message Period
    double Timestamp; /// Min: 0 Max: 0 Units: 
    uint64 Timestamp_raw;
} DB_Report_Message_4_Analog_Card__neoVI;


void DB_Report_Message_4_Analog_Card__neoVI_Init(DB_Report_Message_4_Analog_Card__neoVI * pMsg);
int DB_Report_Message_4_Analog_Card__neoVI_Transmit(DB_Report_Message_4_Analog_Card__neoVI * pMsg);
int DB_Report_Message_4_Analog_Card__neoVI_Transmit_raw(DB_Report_Message_4_Analog_Card__neoVI * pMsg);
int DB_Report_Message_4_Analog_Card__neoVI_UpdateBytesFromSignals(DB_Report_Message_4_Analog_Card__neoVI * pMsg);
int DB_Report_Message_4_Analog_Card__neoVI_UpdateBytesFromRawSignals(DB_Report_Message_4_Analog_Card__neoVI * pMsg);

uint64 DB_Report_Message_4_Analog_Card__neoVI_Timestamp_PhysicalToRaw(double dPhysicalValue);
void DB_Report_Message_4_Analog_Card__neoVI_ClearStats();
extern int DB_PLASMA_Time_Resync_neoVI_Index;
typedef struct {
    GenericMessage MessageData; /// Message Data
    MessageStats Statistics; /// Message Statistics
    int iDefaultPeriodMilliseconds; /// Default Message Period
    double Timestamp; /// Min: 0 Max: 0 Units: ms
    uint64 Timestamp_raw;
} DB_PLASMA_Time_Resync_neoVI;


void DB_PLASMA_Time_Resync_neoVI_Init(DB_PLASMA_Time_Resync_neoVI * pMsg);
int DB_PLASMA_Time_Resync_neoVI_Transmit(DB_PLASMA_Time_Resync_neoVI * pMsg);
int DB_PLASMA_Time_Resync_neoVI_Transmit_raw(DB_PLASMA_Time_Resync_neoVI * pMsg);
int DB_PLASMA_Time_Resync_neoVI_UpdateBytesFromSignals(DB_PLASMA_Time_Resync_neoVI * pMsg);
int DB_PLASMA_Time_Resync_neoVI_UpdateBytesFromRawSignals(DB_PLASMA_Time_Resync_neoVI * pMsg);

uint64 DB_PLASMA_Time_Resync_neoVI_Timestamp_PhysicalToRaw(double dPhysicalValue);
void DB_PLASMA_Time_Resync_neoVI_ClearStats();
extern int DB_PLASMA_Clock_Edge_neoVI_Index;
typedef struct {
    GenericMessage MessageData; /// Message Data
    MessageStats Statistics; /// Message Statistics
    int iDefaultPeriodMilliseconds; /// Default Message Period
} DB_PLASMA_Clock_Edge_neoVI;


void DB_PLASMA_Clock_Edge_neoVI_Init(DB_PLASMA_Clock_Edge_neoVI * pMsg);
int DB_PLASMA_Clock_Edge_neoVI_Transmit(DB_PLASMA_Clock_Edge_neoVI * pMsg);
int DB_PLASMA_Clock_Edge_neoVI_Transmit_raw(DB_PLASMA_Clock_Edge_neoVI * pMsg);
void DB_PLASMA_Clock_Edge_neoVI_ClearStats();
extern int DB_VNET_A_Stats_neoVI_Index;
typedef struct {
    GenericMessage MessageData; /// Message Data
    MessageStats Statistics; /// Message Statistics
    int iDefaultPeriodMilliseconds; /// Default Message Period
    double msgTotal; /// Min: 0 Max: 0 Units: 
    uint64 msgTotal_raw;
    double rxSize; /// Min: 0 Max: 0 Units: 
    uint64 rxSize_raw;
    double scCnt; /// Min: 0 Max: 0 Units: 
    uint64 scCnt_raw;
    double yields; /// Min: 0 Max: 0 Units: 
    uint64 yields_raw;
    double bytesRead; /// Min: 0 Max: 0 Units: 
    uint64 bytesRead_raw;
} DB_VNET_A_Stats_neoVI;


void DB_VNET_A_Stats_neoVI_Init(DB_VNET_A_Stats_neoVI * pMsg);
int DB_VNET_A_Stats_neoVI_Transmit(DB_VNET_A_Stats_neoVI * pMsg);
int DB_VNET_A_Stats_neoVI_Transmit_raw(DB_VNET_A_Stats_neoVI * pMsg);
int DB_VNET_A_Stats_neoVI_UpdateBytesFromSignals(DB_VNET_A_Stats_neoVI * pMsg);
int DB_VNET_A_Stats_neoVI_UpdateBytesFromRawSignals(DB_VNET_A_Stats_neoVI * pMsg);

uint64 DB_VNET_A_Stats_neoVI_msgTotal_PhysicalToRaw(double dPhysicalValue);

uint64 DB_VNET_A_Stats_neoVI_rxSize_PhysicalToRaw(double dPhysicalValue);

uint64 DB_VNET_A_Stats_neoVI_scCnt_PhysicalToRaw(double dPhysicalValue);

uint64 DB_VNET_A_Stats_neoVI_yields_PhysicalToRaw(double dPhysicalValue);

uint64 DB_VNET_A_Stats_neoVI_bytesRead_PhysicalToRaw(double dPhysicalValue);
void DB_VNET_A_Stats_neoVI_ClearStats();
extern int DB_VNET_A_Reboot_neoVI_Index;
typedef struct {
    GenericMessage MessageData; /// Message Data
    MessageStats Statistics; /// Message Statistics
    int iDefaultPeriodMilliseconds; /// Default Message Period
} DB_VNET_A_Reboot_neoVI;


void DB_VNET_A_Reboot_neoVI_Init(DB_VNET_A_Reboot_neoVI * pMsg);
int DB_VNET_A_Reboot_neoVI_Transmit(DB_VNET_A_Reboot_neoVI * pMsg);
int DB_VNET_A_Reboot_neoVI_Transmit_raw(DB_VNET_A_Reboot_neoVI * pMsg);
void DB_VNET_A_Reboot_neoVI_ClearStats();
extern int DB_neoVI_Went_To_Sleep_neoVI_Index;
typedef struct {
    GenericMessage MessageData; /// Message Data
    MessageStats Statistics; /// Message Statistics
    int iDefaultPeriodMilliseconds; /// Default Message Period
} DB_neoVI_Went_To_Sleep_neoVI;


void DB_neoVI_Went_To_Sleep_neoVI_Init(DB_neoVI_Went_To_Sleep_neoVI * pMsg);
int DB_neoVI_Went_To_Sleep_neoVI_Transmit(DB_neoVI_Went_To_Sleep_neoVI * pMsg);
int DB_neoVI_Went_To_Sleep_neoVI_Transmit_raw(DB_neoVI_Went_To_Sleep_neoVI * pMsg);
void DB_neoVI_Went_To_Sleep_neoVI_ClearStats();
extern int DB_PLASMA_subsystem_restarted__neoVI_Index;
typedef struct {
    GenericMessage MessageData; /// Message Data
    MessageStats Statistics; /// Message Statistics
    int iDefaultPeriodMilliseconds; /// Default Message Period
} DB_PLASMA_subsystem_restarted__neoVI;


void DB_PLASMA_subsystem_restarted__neoVI_Init(DB_PLASMA_subsystem_restarted__neoVI * pMsg);
int DB_PLASMA_subsystem_restarted__neoVI_Transmit(DB_PLASMA_subsystem_restarted__neoVI * pMsg);
int DB_PLASMA_subsystem_restarted__neoVI_Transmit_raw(DB_PLASMA_subsystem_restarted__neoVI * pMsg);
void DB_PLASMA_subsystem_restarted__neoVI_ClearStats();
extern int DB_Video_Recording_Report_neoVI_Index;
typedef struct {
    GenericMessage MessageData; /// Message Data
    MessageStats Statistics; /// Message Statistics
    int iDefaultPeriodMilliseconds; /// Default Message Period
    double Recording_in_progress; /// Min: 0 Max: 0 Units: 
    uint64 Recording_in_progress_raw;
    double FPGA_Com_Alive; /// Min: 0 Max: 0 Units: 
    uint64 FPGA_Com_Alive_raw;
    double Bad_Chip; /// Min: 0 Max: 0 Units: 
    uint64 Bad_Chip_raw;
    double uBLogTOCnt; /// Min: 0 Max: 0 Units: 
    uint64 uBLogTOCnt_raw;
    double FPGAComTOCnt; /// Min: 0 Max: 0 Units: 
    uint64 FPGAComTOCnt_raw;
    double SockConfigTOCnt; /// Min: 0 Max: 0 Units: 
    uint64 SockConfigTOCnt_raw;
    double SockActivityTOCnt; /// Min: 0 Max: 0 Units: 
    uint64 SockActivityTOCnt_raw;
    double SockDisconCnt; /// Min: 0 Max: 0 Units: 
    uint64 SockDisconCnt_raw;
    double WcfSM; /// Min: 0 Max: 0 Units: 
    uint64 WcfSM_raw;
} DB_Video_Recording_Report_neoVI;


void DB_Video_Recording_Report_neoVI_Init(DB_Video_Recording_Report_neoVI * pMsg);
int DB_Video_Recording_Report_neoVI_Transmit(DB_Video_Recording_Report_neoVI * pMsg);
int DB_Video_Recording_Report_neoVI_Transmit_raw(DB_Video_Recording_Report_neoVI * pMsg);
int DB_Video_Recording_Report_neoVI_UpdateBytesFromSignals(DB_Video_Recording_Report_neoVI * pMsg);
int DB_Video_Recording_Report_neoVI_UpdateBytesFromRawSignals(DB_Video_Recording_Report_neoVI * pMsg);

uint64 DB_Video_Recording_Report_neoVI_Recording_in_progress_PhysicalToRaw(double dPhysicalValue);

uint64 DB_Video_Recording_Report_neoVI_FPGA_Com_Alive_PhysicalToRaw(double dPhysicalValue);

uint64 DB_Video_Recording_Report_neoVI_Bad_Chip_PhysicalToRaw(double dPhysicalValue);

uint64 DB_Video_Recording_Report_neoVI_uBLogTOCnt_PhysicalToRaw(double dPhysicalValue);

uint64 DB_Video_Recording_Report_neoVI_FPGAComTOCnt_PhysicalToRaw(double dPhysicalValue);

uint64 DB_Video_Recording_Report_neoVI_SockConfigTOCnt_PhysicalToRaw(double dPhysicalValue);

uint64 DB_Video_Recording_Report_neoVI_SockActivityTOCnt_PhysicalToRaw(double dPhysicalValue);

uint64 DB_Video_Recording_Report_neoVI_SockDisconCnt_PhysicalToRaw(double dPhysicalValue);

uint64 DB_Video_Recording_Report_neoVI_WcfSM_PhysicalToRaw(double dPhysicalValue);
void DB_Video_Recording_Report_neoVI_ClearStats();
void SpyMsg_MG_TesterToECU_HS_CAN(MG_TesterToECU_HS_CAN * pMG_TesterToECU_HS_CAN);
void SpyMsg_TX_ECU_To_Tester_HS_CAN(TX_ECU_To_Tester_HS_CAN * pTX_ECU_To_Tester_HS_CAN);

#endif // VSPY_GENERATED_HEADER
